* Derived table (Sub-select as part of FROM)
* Returns customer ID and product count for all customers 
* who have purchased at least 40% of the product line. 

CLOSE DATABASES ALL
OPEN DATABASE Northwind

LOCAL lnPct
lnPct = .40
 
SELECT ;
   C.customerid, ;
   C.companyname, ;
   P.p_count AS Product_Count;
  FROM Customers C, ;
     (SELECT c2.customerid, ; 
       COUNT(DISTINCT D.productID) AS p_count ;
        FROM Customers C2 ;
       INNER JOIN Orders O ;
          ON  C2.customerid = O.customerid ;
       INNER JOIN OrderDetails D ;
          ON O.orderid = D.orderid ;
       GROUP BY c2.customerid) AS P ;
 WHERE C.customerID = p.customerID ;
   AND P.p_count >= ;
      (SELECT (COUNT(*)*m.lnPct) FROM Products WHERE NOT EMPTY(ProductName)) ;
 ORDER BY p.p_count DESC

CLOSE DATABASES ALL